﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace SDK1
{
    public partial class SDK_USBm_SONY : Form
    {

        object sModel;
        int nTOTPixelNo, nRealPixelNo, EffectivePixelIndex;

        public SDK_USBm_SONY()
        {
            InitializeComponent();
        }


        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spTestAllChannels(short sOrderType);

        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spSetupAllChannels();
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spSetupGivenChannel(short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spInitAllChannels(short sCCDType);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spInitGivenChannel(short sCCDType, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spSetIntEx(long lIntTime, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spSetDblIntEx(long lIntTime, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spSetTrgEx(short sTrgType, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spReadDataEx(out long lpArray, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spCloseAllChannels();
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spCloseGivenChannel(short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spWriteChannelID(short sNum, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spReadChannelID(short* spNum, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern void spGetAssignedChannelID(short* spChannelID);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern void spPolyCalc(double* coefs, short order, double x, double* y);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spPolyFit(double* x, double* y, short numPts, double* coefs, short order);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spSetIntMode(short IntMode, double dIntTime, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spSetExtEdgeMode(short EdgeMode, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]      
        public unsafe static extern short spCheckSpeedMode(int* nCheckSpeed, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spGetDevIsNew(short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spDevInfo(string strModel, string strSerial, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spGetWLTable(double* WLTable, short sChannel);
        
        [DllImport("SPdbUSBm.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public unsafe static extern short spDupdate(int ScanAvg, int smooth, short sChannel);

      

        private void CheckConnections_Click(object sender, EventArgs e)
        {

            short sRtn;

            sRtn = spTestAllChannels(0);

            if (sRtn > 0)
            { // OK

                CheckConText.Text = ("Testing the USB borad... OK!");


            }
            else
            {
                CheckConText.Text = ("The USB board does not work correctly.");

            }

        }

        private unsafe void CheckChannels_Click(object sender, EventArgs e)
        {
            int sRtn;
            short SpType;


            sRtn = spSetupAllChannels();
            if (sRtn > 0)
            {
                CheckChnText.Text = "Setup Channels...OK!";

                if (Model.Items.Contains("SM24X"))
                {
                    nTOTPixelNo = 2080;
                    nRealPixelNo = 2048;
                    SpType = 0;
                }
                else if (Model.Items.Contains("SM44X"))
                {
                    nTOTPixelNo = 3680;
                    nRealPixelNo = 3648;
                    SpType = 1;
                }
                else if (Model.Items.Contains("SM303"))
                {
                    nTOTPixelNo = 1056;
                    nRealPixelNo = 1024;
                    SpType = 2;
                }
                else if (Model.Items.Contains("SM642"))
                {
                    nTOTPixelNo = 2080;
                    nRealPixelNo = 2048;
                    SpType = 3;
                }
            }
            else
            {
                CheckChnText.Text = "Setup Channels...Error!";
            }


            if (sRtn > 0)
            {
               
                double[] DataArray = new double[nTOTPixelNo];

                double*[] WLTableArray = new double*[nRealPixelNo];

                sRtn =Convert.ToInt32(spGetWLTable(WLTableArray[0], 0));

            }




        }

    }
}




    

